; [Programming Principle Project : "Quang" ]
; OUR TEAM : "막판 뒤집기" (Reverse Grade)
; LAST MODIFIED 2006.06.07(Wed) - Funny Night
; ==================================================================

;====================================================================
;***********                init function               *************
;====================================================================

; init : unit -> (Pos * Color) list
; Board-size can be changed.
(define (init)
  
  ; team-check
  (define our-team-id 'a)                
  (define (is-a?) (equal? our-team-id 'b))
  
  ; pos
  (define (get-pos x y) (cons x y))
  (define (get-x-pos pos) (car pos))
  (define (get-y-pos pos) (cdr pos))
  
  ; board-size
  (define board-height-min -3)
  (define board-height-max 3)
  (define board-width-min -3)
  (define board-width-max 3)
  
  (define get-width-middle (if (odd? board-width-max) (/ (- board-width-max board-width-min) 2) 
                                         (/ (+ (- board-width-max board-width-min) 1) 2)))
  (define max-init-height 2)
  (define max-init-forward (if (is-a?) max-init-height (- board-height-max max-init-height)))
  
  (define get-left-base (if (is-a?) (get-pos board-width-min board-height-min)
                            (get-pos board-width-max board-height-max)))  
  (define get-right-base (if (is-a?) (get-pos board-width-max board-height-min)
                            (get-pos board-width-min board-height-max)))  
  
  ; neighbor-positon  
  (define (up-pos pos) (if (is-a?) (cons (get-x-pos pos) (+ (get-y-pos pos) 1))
                            (cons (get-x-pos pos) (- (get-y-pos pos) 1))))
  (define (down-pos pos) (if (is-a?) (cons (get-x-pos pos) (- (get-y-pos pos) 1))
                            (cons (get-x-pos pos) (+ (get-y-pos pos) 1))))
  (define (right-pos pos) (if (is-a?) (cons (+ (get-x-pos pos) 1) (get-y-pos pos))
                            (cons (- (get-x-pos pos) 1) (get-y-pos pos))))
  (define (left-pos pos) (if (is-a?) (cons (- (get-x-pos pos) 1) (get-y-pos pos))
                            (cons (+ (get-x-pos pos) 1) (get-y-pos pos))))
  
  ; color 
  (define red '"Red")
  (define blue '"Blue")
  
  (list 
   ;Red : catch blue unit
   (cons (up-pos (up-pos get-right-base)) blue)    ; both off & def (6, 2) or (0, 4)
   (cons (up-pos (right-pos get-left-base)) red)  ; defense (1, 1) or (5, 5)
   (cons (right-pos (right-pos (up-pos (up-pos get-left-base)))) red)  ; offense (3, 2) or (3, 4)
   (cons (up-pos (left-pos get-right-base)) red)  ; defense (5, 1) or (1, 5)
   (cons (up-pos (up-pos get-left-base)) red)     ; both off & def (0, 2) or (6, 4)
   
          ; Blue : run-away & protect arrow-position
          (cons get-left-base blue) ; keep base (0, 0) or (6, 6)
          (cons get-right-base blue) ; keep base (6, 0) or (0, 6)
          (cons (right-pos get-left-base) blue) ; keep base (1, 0) or (5, 6)
          (cons (left-pos get-right-base) blue) ; keep base (5, 0) or (1, 6)
          (cons (right-pos (right-pos (right-pos get-left-base))) red) ; it's king (3, 0) or (3, 6)
          ))           

;(init)

;;; 황창호

(define ourTeamId '"A")

(define max-x 3)
(define max-y 3)
(define min-x -3)
(define min-y -3)

(define defense-pos-1 (cons -2 2))
(define defense-pos-2 (cons 2 2))
(define goal-pos-1 (cons -3 -3))
(define goal-pos-2 (cons 3 -3))

(define (is-in-defense-critical-range? pos)
  (let ((x (get-x-from-pos pos))
        (y (get-y-from-pos pos)))
    (and (>= y 2)
         (or (<= x -2) (>= x 2)))))


(define (is-bottom-start?) (equal? ourTeamId '"B"))

(define total-our-red-count 5)
(define total-our-blue-count 5)
(define total-your-red-count total-our-red-count)
(define total-your-blue-count total-our-blue-count)
 
(define (is-alive-pos? pos)
  (letrec ((thisPos-x (get-x-from-pos pos))
           (thisPos-y (get-y-from-pos pos)))
    (and
     (and (<= thisPos-x  max-x) (>= thisPos-x min-x))
     (and (<= thisPos-y  max-y) (>= thisPos-y min-y)))))

(define (is-dead-pos? pos)
  (not (is-alive-pos? pos)))

(define Red '"Red")
(define Blue '"Blue")
(define White '"White")

(define Up '"Up")
(define Down '"Down")
(define Left '"Left")
(define Right '"Right")

(define (get-pos x y) (cons x y))
(define (get-x-from-pos pos) (car pos))
(define (get-y-from-pos pos) (cdr pos))

(define (get-board-from-pos-state pos state)
  (cons pos state))
(define (get-pos-from-board board) (car board))
(define (get-state-from-board board) (cdr board))

(define (get-id-from-state state) (car state))
(define (get-color-from-state state) (cdr state))

(define (is-ourTeam? state)
  (equal? (get-id-from-state state) ourTeamId))

(define (is-yourTeam? state)
  (not (equal? (get-id-from-state state) ourTeamId)))

(define (is-state-red? state)
  (equal? (get-color-from-state state) Red))

(define (is-state-blue? state)
  (equal? (get-color-from-state state) Blue))

(define (get-our-dead-red-count boardList) (get-unit-count-by-pos-cond is-dead-pos? is-state-red? is-ourTeam? boardList))
(define (get-your-dead-red-count boardList) (get-unit-count-by-pos-cond is-dead-pos? is-state-red? is-yourTeam? boardList))
(define (get-our-dead-blue-count boardList) (get-unit-count-by-pos-cond is-dead-pos? is-state-blue? is-ourTeam? boardList))
(define (get-your-dead-blue-count boardList) (get-unit-count-by-pos-cond is-dead-pos? is-state-blue? is-yourTeam? boardList))

(define IMPOSSIBLE_CASE -100000)
(define IMPOSSIBLE_POS (get-pos (+ max-x 1) (+ max-y 1)))
(define IMPOSSIBLE_DIR '"Impossible")


; 
(define (get-unit-count-by-pos-cond cond_pos cond_state1 cond_state2 boardList)
  (if (null? boardList) 0
      (letrec ((thisBoard (car boardList))
               (thisPos (get-pos-from-board thisBoard))
               (thisState (get-state-from-board thisBoard))
               (thisCount (if (and (and (cond_pos thisPos) (cond_state1 thisState)) (cond_state2 thisState)) 1 0)))
        (+ thisCount (get-unit-count-by-pos-cond cond_pos cond_state1 cond_state2 (cdr boardList))))))

(define (get-unit-list cond_pos cond_state boardList)
  (if (null? boardList) null
      (letrec ((thisBoard (car boardList))
               (thisPos (get-pos-from-board thisBoard))
               (thisState (get-state-from-board thisBoard))
               (restUnitList (get-unit-list cond_pos cond_state (cdr boardList))))
        (if (and (cond_pos thisPos) (cond_state thisState)) (cons thisBoard restUnitList)
            restUnitList))))

(define (get-our-alive-unit-list boardList)
  (get-unit-list is-alive-pos? is-ourTeam? boardList))

(define (get-your-alive-unit-list boardList)
  (get-unit-list is-alive-pos? is-yourTeam? boardList))


(define (move boardList)
  (letrec ((our-dead-red-count (get-our-dead-red-count boardList))
           (our-dead-blue-count (get-our-dead-blue-count boardList))
           (your-dead-red-count (get-your-dead-red-count boardList))
           (your-dead-blue-count (get-your-dead-blue-count boardList))
           (our-unit-list (get-our-alive-unit-list boardList))
           (output-score (move-unit our-unit-list
                                    our-unit-list
                                    (get-your-alive-unit-list boardList) 
                                    our-dead-red-count 
                                    our-dead-blue-count 
                                    your-dead-red-count 
                                    your-dead-blue-count))
           )
    ; 여기서 행여 모르니까 score-number 체크를 하면 좋겠다.
    (cons (get-pos-from-score output-score) (get-dir-from-score output-score))))

(define score-tag 'score)
(define (get-score score-number pos dir)
  (list score-tag score-number pos dir))
(define (is-score? score) (equal? (car score) score-tag))
(define (get-score-number-from-score score)
  (if (is-score? score) (cadr score)))
(define (get-pos-from-score score)
  (if (is-score? score) (caddr score)))
(define (get-dir-from-score score)
  (if (is-score? score) (cadddr score)))

(define (move-unit our-unit-list our-alive-unit-list your-alive-unit-list 
                   our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count)
  (if (null? our-unit-list) (get-score IMPOSSIBLE_CASE IMPOSSIBLE_POS IMPOSSIBLE_DIR)
      (letrec ((this-unit (car our-unit-list))
               (thisUnitScore (get-move-unit-score this-unit our-unit-list our-alive-unit-list your-alive-unit-list 
                                                   our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count))
               (restUnitScore (move-unit (cdr our-unit-list) our-alive-unit-list your-alive-unit-list 
                                         our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count)))
        (if (>= (get-score-number-from-score thisUnitScore) (get-score-number-from-score restUnitScore))
            thisUnitScore restUnitScore))))

(define (get-move-unit-score this-unit our-unit-list our-alive-unit-list your-alive-unit-list 
                             our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count)
  (letrec 
      ((left-score-number (get-move-unit-score-number-after-move this-unit Left our-unit-list our-alive-unit-list your-alive-unit-list 
                                                                 our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count))
       (right-score-number (get-move-unit-score-number-after-move this-unit Right our-unit-list our-alive-unit-list your-alive-unit-list 
                                                                  our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count))
       (up-score-number (get-move-unit-score-number-after-move this-unit Up our-unit-list our-alive-unit-list your-alive-unit-list 
                                                               our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count))
       (down-score-number (get-move-unit-score-number-after-move this-unit Down our-unit-list our-alive-unit-list your-alive-unit-list 
                                                                 our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count))
       (max-number (whatIsMax (list left-score-number right-score-number up-score-number down-score-number))))
;       (aaa (print max-number))
;       (bbb (print " ")))
    (cond ((equal? max-number right-score-number) (get-score max-number (get-pos-from-board this-unit) Right))
          ((equal? max-number left-score-number) (get-score max-number (get-pos-from-board this-unit) Left))
          ((equal? max-number up-score-number) (get-score max-number (get-pos-from-board this-unit) Up))
          ((equal? max-number down-score-number) (get-score max-number (get-pos-from-board this-unit) Down))
          (else (error "whatIsMax error")))))
;;; 점수 메기는 부분 시작
(define (get-move-unit-score-number-after-move this-unit dir our-unit-list our-alive-unit-list your-alive-unit-list 
                                               our-dead-red-count our-dead-blue-count your-dead-red-count your-dead-blue-count)
  (letrec (
           (our-unit-list-after-move (get-unit-list-after-move our-alive-unit-list this-unit dir our-alive-unit-list))
           (our-alive-red-count (- total-our-red-count our-dead-red-count))
           (our-alive-blue-count (- total-our-blue-count our-dead-blue-count))
;           (aaa (print (get-pos-from-board this-unit)))
;           (bbb (print (null? our-unit-list-after-move)))
           )
    (if (null? our-unit-list-after-move) IMPOSSIBLE_CASE
        (letrec
            ((goal-in-score_temp (if (is-goal? our-unit-list-after-move) 10000 0))
             (goal-in-score (if (and (>= your-dead-red-count (- total-your-red-count 1)) (> our-alive-blue-count 1)) 0 goal-in-score_temp))
             (defense-score (if (is-defense-good? our-unit-list-after-move) 100 0))
             (kill-enemy-unit (get-kill-enemy-unit our-unit-list-after-move your-alive-unit-list))
             (kill-enemy-score (if (null? kill-enemy-unit) 0 
                                   (if (and (>= your-dead-red-count (- total-your-red-count 1)) (> our-alive-blue-count 1)) -5000
                                       (if (is-in-defense-critical-range? (get-pos-from-board kill-enemy-unit)) 500
                                           (* (- (- total-your-red-count your-dead-red-count) 1) 1)))))
             (will-dead-unit-list (get-will-dead-unit-list our-unit-list-after-move your-alive-unit-list))
             ;(aaa (print will-dead-unit-list))
             (will-dead-score (get-score-number-from-will-dead-unit-list will-dead-unit-list))
             ;(will-dead-score 0)
             (front-unit-count (if (or (and (is-bottom-start?) (equal? dir Up)) (and (not (is-bottom-start?)) (equal? dir Down)))
                                   (get-front-unit-count our-unit-list-after-move) 
                                   0))
;             (front-unit-count-temp (get-front-unit-count our-unit-list-after-move))
;             (front-unit-count (if (or (equal? dir Left) (equal? dir Right)) 0 front-unit-count-temp))
             (front-unit-score (* front-unit-count 2))
             (default-score (if (is-bottom-start?) (if (equal? dir Up) 1 0)
                                (if (equal? dir Down) 1 0)))
             )
          (and
           ;(print this-unit)
           ;(print dir)
           ;(print (+ goal-in-score defense-score kill-enemy-score will-dead-score front-unit-score default-score))
           ;(print our-unit-list-after-move)
           ;(newline)
           (+ goal-in-score defense-score kill-enemy-score will-dead-score front-unit-score default-score))))))

(define (get-score-number-from-will-dead-unit-list will-dead-unit-list)
  (if (null? will-dead-unit-list) 0
      (let ((rest-score-number (get-score-number-from-will-dead-unit-list (cdr will-dead-unit-list))))
        
        (if (is-state-red? (get-state-from-board (car will-dead-unit-list))) (+ 10 rest-score-number)
            (- rest-score-number 20)))))

;;; 점수 메기는 부분 끝

(define (get-front-unit-count our-unit-list)
  (get-unit-count-by-y our-unit-list (get-front-y our-unit-list)))

(define (get-unit-count-by-y our-unit-list y)
  (if (null? our-unit-list) 0
      (let
          ((this-unit-y (get-y-from-pos (get-pos-from-board (car our-unit-list))))
           (rest-unit-count (get-unit-count-by-y (cdr our-unit-list) y)))
        (if (= this-unit-y y) (+ 1 rest-unit-count) rest-unit-count))))

(define (get-front-y our-unit-list)
  (if (is-bottom-start?) (get-max-y our-unit-list) (get-min-y our-unit-list)))

(define (get-max-y our-unit-list)
  (if (null? our-unit-list) IMPOSSIBLE_CASE
      (let
          ((this-y (get-y-from-pos (get-pos-from-board (car our-unit-list))))
           (rest-max-y (get-max-y (cdr our-unit-list))))
        (if (>= this-y rest-max-y) this-y rest-max-y))))


(define (get-min-y our-unit-list)
  (if (null? our-unit-list) (- 0 IMPOSSIBLE_CASE)
      (let
          ((this-y (get-y-from-pos (get-pos-from-board (car our-unit-list))))
           (rest-min-y (get-min-y (cdr our-unit-list))))
        (if (<= this-y rest-min-y) this-y rest-min-y))))

(define (get-will-dead-unit-list our-unit-list your-unit-list)
  (if (null? our-unit-list) null
      (let
          ((our-unit (car our-unit-list))
           (rest-will-dead-unit-list (get-will-dead-unit-list (cdr our-unit-list) your-unit-list)))
        (if (is-in-range? (get-pos-from-board our-unit) your-unit-list) (cons our-unit rest-will-dead-unit-list)
            rest-will-dead-unit-list))))

  
(define (get-kill-enemy-unit our-unit-list your-unit-list)
  (if (null? our-unit-list) null
      (let
          ((our-unit (car our-unit-list)))
        (if (is-in-list? (get-pos-from-board our-unit) your-unit-list) our-unit
            (get-kill-enemy-unit (cdr our-unit-list) your-unit-list)))))

(define (is-defense-good? our-unit-list)
  (and (is-in-list? defense-pos-1 our-unit-list) (is-in-list? defense-pos-2 our-unit-list)))

(define (is-goal? our-unit-list)
  (or (is-in-list? goal-pos-1 our-unit-list) (is-in-list? goal-pos-2 our-unit-list)))

; 마지막 인자는 움직일 위치에 이미 우리편 유닛이 있는지 확인하기 위함
(define (get-unit-list-after-move our-unit-list this-unit dir total-our-unit-list)
  (if (null? our-unit-list) (error "wrong our unit list")
      (letrec ((car-unit (car our-unit-list)))
        (if (equal? car-unit this-unit)
            (letrec ((this-unit-pos (get-pos-from-board this-unit))
                     (this-unit-pos-x (get-x-from-pos this-unit-pos))
                     (this-unit-pos-y (get-y-from-pos this-unit-pos))
                     (this-unit-state (get-state-from-board this-unit))
                     (next-unit-pos (cond ((equal? dir Left) (get-pos (- this-unit-pos-x 1) this-unit-pos-y))         
                                          ((equal? dir Right) (get-pos (+ this-unit-pos-x 1) this-unit-pos-y))
                                          ((equal? dir Up) (get-pos this-unit-pos-x (+ this-unit-pos-y 1)))
                                          ((equal? dir Down) (get-pos this-unit-pos-x (- this-unit-pos-y 1)))
                                          (else (error "wrong dir"))))
                     )
              
              (cond ((not (is-alive-pos? next-unit-pos)) null)
                    ((is-in-list? next-unit-pos total-our-unit-list) null)
                    (else (cons (get-board-from-pos-state next-unit-pos this-unit-state) (cdr our-unit-list)))))
                    
            (cons car-unit (get-unit-list-after-move (cdr our-unit-list) this-unit dir total-our-unit-list))))))
            
(define (is-in-list? pos board-list)
  (if (null? board-list) #f
      (letrec ((this-board (car board-list))
               (this-board-pos (get-pos-from-board this-board)))
        (if (equal? this-board-pos pos) #t (is-in-list? pos (cdr board-list))))))

(define (is-in-range? pos board-list)
  (letrec ((pos-x (get-x-from-pos pos))
           (pos-y (get-y-from-pos pos))
           (next-pos-1 (get-pos (+ pos-x 1) pos-y))
           (next-pos-2 (get-pos (- pos-x 1) pos-y))
           (next-pos-3 (get-pos pos-x (+ pos-y 1)))
           (next-pos-4 (get-pos pos-x (- pos-y 1)))
           )
    (or
     (is-in-list? next-pos-1 board-list)
     (is-in-list? next-pos-2 board-list)
     (is-in-list? next-pos-3 board-list)
     (is-in-list? next-pos-4 board-list))))
           
;;; 리스트 중 제일 큰 숫자 리턴
(define (whatIsMax l)
  (if (null? (cdr l)) (car l)
      (let ((thisItem (car l))
            (lastMaxItem (whatIsMax (cdr l))))
        (if (>= thisItem lastMaxItem) thisItem lastMaxItem))))

;;; 리스트 중 제일 작은 숫자 리턴
(define (whatIsMin l)
  (if (null? (cdr l)) (car l)
      (let ((thisItem (car l))
            (lastMinItem (whatIsMin (cdr l))))
        (if (<= thisItem lastMinItem) thisItem lastMinItem))))

           
;(define input
;  (list 
;   (cons (cons -7 -7) (cons "B" "Red")) 
;   (cons (cons -7 -7) (cons "B" "Blue")) 
;   (cons (cons -7 -7) (cons "B" "Red")) 
;   (cons (cons -7 -7) (cons "B" "Red")) 
;   (cons (cons -7 -7) (cons "B" "Red")) 
;   (cons (cons -7 -7) (cons "A" "Blue")) 
;   (cons (cons -7 -7) (cons "A" "Blue")) 
;   (cons (cons -7 -7) (cons "A" "Red")) 
;   
;   (cons (cons -2 3) (cons "A" "Blue")) 
;   (cons (cons -3 1) (cons "A" "Blue")) 
;   
;   (cons (cons -3 2) (cons "B" "Red"))
;   (cons (cons 2 -2) (cons "B" "Blue")) 
;   (cons (cons -1 1) (cons "B" "Blue")) 
;   (cons (cons 0 0) (cons "B" "Blue")) 
;   (cons (cons 1 -1) (cons "B" "Blue")) 
;   (cons (cons 2 -3) (cons "B" "Blue"))));

;(move input)
