; +---------------------------------------+
; | 2006년 프로그래밍의 원리 프로 트     |
; +---------------------------------------+
; | 팀명 : Mighty Rangers                 |
; | 팀원 : 오한웅/컴퓨터공학부/99328-219  | 
; |        서보경/통계학과/2004-10856     |
; +---------------------------------------+




;--------------------------- 기본 상수 ------------------------------

;Define Team id
;팀 ID 설 : #t이면 A팀 #f이면 B팀 
;이 설 에 따라 좌표계와 이동방향이 모두 바뀐다.
(define isTeamA? #f)

;Define direction
(define mDown (if isTeamA? "Up" "Down"))
(define mUp (if isTeamA? "Down" "Up"))
(define mRight (if isTeamA? "Left" "Right"))
(define mLeft (if isTeamA? "Right" "Left"))

;Define color
(define mRed "Red")
(define mBlue "Blue")
(define mWhite "White")

;Define Id
(define mAlliance (if isTeamA? "A" "B"))
(define mEnemy (if isTeamA? "B" "A"))

;isConverted : 우리가 뒤집힌 좌표계에 있는지 확인
(define isConverted? isTeamA?)

;--------------------------- 기본 함수 -------------------------------
;Position
;int * int -> mPos
(define (mPos x y)
  (cons x y))

(define (pX po)
  (car po))

(define (pY po)
  (cdr po))

;State
;id * color -> mState
(define (mState id color)
  (list id color))

;mMove 
(define (mMove po dir)
  (list po dir))

;converse : mPos -> mPos
;좌표계를 뒤집어주는 함수
(define (converse po)
  (cond ((= -4 (pX po)) (mPos -4 (pY po)))
        ((= -4 (pX po)) (mPos -4 (pY po))) 
        (else (mPos (- 6 (pX po)) (- 6 (pY po))))))

(define (tranPos po)
  (mPos (- (car po) 3) (- (cdr po) 3)))



(define (dLookup d po)
  (define lk (filter (lambda (k) (equal? (car k) po)) d))
  (if (null? lk) 'bottom
      (cdar lk)))
  

;mLookup : Pos * Dict -> Id * Color
;사 에서 해당좌표의  닛을 검색해주는 함수
(define (mLookup po dic)
  (define cpo (tranPos (converse po)))
  (define tpo (tranPos po))
  (if isConverted? 
      (dLookup dic cpo)
      (dLookup dic tpo)))


;mLookup : Pos * Dict -> Id * Color
;사 에서 해당좌표의  닛을 검색해주는 함수
(define (oLookup po dic)
  (define cpo (converse po))
  (if isConverted? 
      (dLookup dic cpo)
      (dLookup dic po)))

;numRedKill : Board -> int
;우리가 죽인  의 Red의 갯수
(define (numRedKill B)
  (define (numRedKillItr B n)
    (if (< n -10) 
        0
        (if (equal? (cdr (mLookup (mPos -1 n) B)) mRed)
            (+ 1 (numRedKillItr B (- n 1)))
            (numRedKillItr B (- n 1)))))
  (numRedKillItr B -1))
            
;boardToList : Board -> mPos * (Id * Color) list
;사 으로 된 보드 보를 리스트로 바꿔줌
(define (boardToList B)
  (map (lambda (k) (cons (cons (+ (bX k) 3) (+ (bY k) 3)) (cdr k))) B))
    
(define (blId bList) (cadar bList))
(define (blColor bList) (cddar bList))
(define (blPos bList) (caar bList))
(define (blX bList) (caaar bList))
(define (blY bList) (cdaar bList))

(define (bId bList) (cadr bList))
(define (bColor bList) (cddr bList))
(define (bPos bList) (car bList))
(define (bX bList) (caar bList))
(define (bY bList) (cdar bList))

;enemyUnitCenter : boardList -> int
;   닛이 중앙을 기준으로 어느쪽에 편중되었는지 계산
;-이면 좌측, +이면 우측, 0이면 편중없음
(define (enemyUnitCenter bList)
  (cond ((null? bList) 0)
        ((equal? (blColor bList) mWhite) 
         (+ (- (blX bList) 3) (enemyUnitCenter (cdr bList))))
        (else (enemyUnitCenter (cdr bList)))))

(define (liveFilter bList lv?)
  (if lv?
      (unitAccess bList (mPos 0 0) (mPos 6 6))
      (unitAccess bList (mPos -4 -4) (mPos -4 -4))))

;idFilter boardList * Id => boardList
;해당 id로 필터링
(define (idFilter bList id)
  (filter (lambda (x) (equal? id (bId x))) (liveFilter bList #t)))

;idFilter boardList * color => boardList
;해당 color로 필터링
(define (colorFilter bList co)
  (filter (lambda (x) (equal? co (bColor x))) (liveFilter bList #t)))

;unitAccess : boardList * Pos * Pos => boardList
;해당 범위 내의  닛을 검색하는 함수
;pos 두개는 두  을 찍어 그것이 모서리되는 직사각형 내의 범위
(define (unitAccess bList p1 p2)
  (filter (lambda (x) (and (if (< (pX p1) (pX p2)) 
                               (and (<= (pX p1) (bX x))
                                    (<= (bX x) (pX p2)))
                               (and (<= (pX p2) (bX x))
                                    (<= (bX x) (pX p1))))
                           (if (< (pY p1) (pY p2)) 
                               (and (<= (pY p1) (bY x))
                                    (<= (bY x) (pY p2)))
                               (and (<= (pY p2) (bY x))
                                    (<= (bY x) (pY p1))))))
          bList))

;rangeAccess : boardList * Pos => boardList
;해당 좌표의 사 거리에 있는  닛을 검색하는 함수
;pos: 좌표
(define (rangeAccess bList po)
  (if (or (null? bList) (null? po)) null
  (filter (lambda (x) (or (and (< 0 (car po))
                                    (= (bX x) (- (pX po) 1))
                                    (= (bY x) (pY po)))
                               (and (> 6 (car po))
                                    (= (bX x) (+ (pX po) 1))
                                    (= (bY x) (pY po)))
                               (and (< 0 (cdr po))
                                    (= (bY x) (- (pY po) 1))
                                    (= (bX x) (pX po)))
                               (and (> 6 (cdr po))
                                    (= (bY x) (+ (pY po) 1))
                                    (= (bX x) (pX po)))))
          bList)))

;distance : Pos * Pos => int
;두 좌표의 거리를 움직여야 하는 횟수로 나타내주는 함수
(define (distance p1 p2)
  (+ (abs (- (pX p1) (pX p2)))
     (abs (- (pY p1) (pY p2)))))
     
;리스트의 최소값을 돌 주는 함수     
(define (minList lst)
    (cond ((null? lst) 100)
          ((> (car lst) (minList (cdr lst))) (minList (cdr lst)))
          (else (car lst))))

;리스트의 최대값을 돌 주는 함수     
(define (maxList lst)
    (cond ((null? lst) 0)
          ((< (car lst) (maxList (cdr lst))) (maxList (cdr lst)))
          (else (car lst))))

;nearestUnit : boardList * Pos => boardList
;해당 좌표에서 가장 가까운  닛을 검색해주는 함수
(define (nearestUnit bList po)
  (let ((minVal (minList (map (lambda (x) (distance (car x) po)) 
                              bList))))
    (filter (lambda (x) (= minVal (distance (car x) po))) bList)))

;frontLineAlliance : boardList -> boardList
;가장 위에 있는  닛들을 검색해주는 함수
(define (frontLine bList)
  (let ((maxVal (maxList (map (lambda (x) (cdar x)) bList))))
    (filter (lambda (x) (= maxVal (cdar x)))  bList)))

;rightlineAlliance : boardList -> boardList
;가장 우측방에 있는  닛들을 검색해주는 함수
(define (rightLine bList)
  (let ((maxVal (maxList (map (lambda (x) (caar x)) bList))))
    (filter (lambda (x) (= maxVal (caar x))) bList)))

;leftlineAlliance : boardList -> boardList
;가장 좌측방에 있는  닛들을 검색해주는 함수
(define (leftLine bList)
  (let ((minVal (minList (map (lambda (x) (caar x)) bList))))
    (filter (lambda (x) (= minVal (caar x))) bList)))

;rearlineAlliance : boardList -> boardList
;가장 아래에 있는  닛들을 검색해주는 함수
(define (rearLine bList)
  (let ((minVal (minList (map (lambda (x) (cdar x)) bList))))
    (filter (lambda (x) (= minVal (cdar x))) bList)))

;----------------------------------- move -------------------------------------
(define (movement po di)
  (cons po di))

;안 한가?
(define (isSafeMove? B mo)
  (define dest (cond ((equal? (cdr mo) mUp) (mPos (caar mo) (+ 1 (cdar mo))))
                     ((equal? (cdr mo) mDown) (mPos (caar mo) (- (cdar mo) 1)))
                     ((equal? (cdr mo) mRight) (mPos (+ 1 (caar mo)) (cdar mo)))
                     ((equal? (cdr mo) mLeft) (mPos (- (caar mo) 1) (cdar mo)))))
  (not (or (> 0 (pX dest)) (< 6 (pX dest)) 
           (> 0 (pY dest)) (< 6 (pY dest))
           (if (equal? (oLookup dest B) 'bottom)
               #f
               (equal? mAlliance (car (oLookup dest B)))))))
 
;후퇴
(define (withDraw bList po)
  (cond ((isSafeMove? bList (cons po mDown)) (cons po mDown))
        ((isSafeMove? bList (cons po mRight)) (cons po mRight))
        ((isSafeMove? bList (cons po mLeft)) (cons po mLeft))
        ((isSafeMove? bList (cons po mUp)) (cons po mUp))
        (else (randomFront bList))))

;앞으로
(define (fronting bList po)
  (cond ((isSafeMove? bList (cons po mUp)) (cons po mUp))
        ((isSafeMove? bList (cons po mRight)) (cons po mRight))
        ((isSafeMove? bList (cons po mLeft)) (cons po mLeft))
        ((isSafeMove? bList (cons po mDown)) (cons po mDown))
        (else (randomFront bList))))

;이동
(define (makeMove bList startPos destPos)
  (if (> (abs (- (pX startPos) (pX destPos))) (abs (- (pY startPos) (pY destPos))))
  (cond ((and (< (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mRight))) (cons startPos mRight))
        ((and (> (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mLeft))) (cons startPos mLeft))
        ((and (< (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mUp))) (cons startPos mUp))
        ((and (> (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mDown))) (cons startPos mDown))
        (else (randomFront bList)))
  (cond ((and (< (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mUp))) (cons startPos mUp))
        ((and (> (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mDown))) (cons startPos mDown))
        ((and (< (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mRight))) (cons startPos mRight))
        ((and (> (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mLeft))) (cons startPos mLeft))
        (else (randomFront bList)))))

;안 한이동
(define (makeSafeMove bList startPos destPos nx)
  (if #t;(> (abs (- (pX startPos) (pX destPos))) (abs (- (pY startPos) (pY destPos))))
  (cond ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (+ (pX startPos) 1) (pY startPos))))
              (< (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mRight))) (cons startPos mRight))
        ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (- (pX startPos) 1) (pY startPos))))
              (> (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mLeft))) (cons startPos mLeft))
        ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (pX startPos) (+ (pY startPos) 1))))
              (< (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mUp))) (cons startPos mUp))
        ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (pX startPos) (- (pY startPos) 1))))
              (> (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mDown))) (cons startPos mDown))
        (else (nx bList)))
  (cond ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (pX startPos) (+ (pY startPos) 1))))
              (< (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mUp))) (cons startPos mUp))
        ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (pX startPos) (- (pY startPos) 1))))
              (> (pY startPos) (pY destPos)) (isSafeMove? bList (cons startPos mDown))) (cons startPos mDown))
        ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (+ (pX startPos) 1) (pY startPos))))
              (< (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mRight))) (cons startPos mRight))
        ((and (null? (rangeAccess (idFilter bList mEnemy) (cons (- (pX startPos) 1) (pY startPos))))
              (> (pX startPos) (pX destPos)) (isSafeMove? bList (cons startPos mLeft))) (cons startPos mLeft))
        (else (nx bList)))))

(define (XXXXX) 'x)

;오른쪽방어
(define (rightSideDefence bList)
  (define nextSt leftSideDefence)
  (define enemyP (unitAccess (idFilter bList mEnemy) (mPos 4 2) (mPos 6 0)))
  (define enemyPos (if (null? enemyP) null (blPos enemyP)))
  (define allianceList (unitAccess (idFilter bList mAlliance) (mPos 4 1) (mPos 6 0)))
    (let ((attacker (rangeAccess allianceList enemyPos)))
      (cond ((or (null? enemyPos) (null? attacker)) (nextSt bList))
            ((not (null? (colorFilter attacker mRed))) (makeMove bList (blPos attacker) enemyPos))
            ((and (> 6 (blX attacker)) (= 1 (blY attacker))) (withDraw bList (blPos attacker)))
            ((not (null? attacker)) (makeMove bList (blPos attacker) enemyPos))
            (else (nextSt bList)))))
      
(define (leftSideDefence bList)
  (define nextSt selectLR)
  (define enemyP (unitAccess (idFilter bList mEnemy) (mPos 2 2) (mPos 0 0)))
  (define enemyPos (if (null? enemyP) null (blPos enemyP)))
  (define allianceList (unitAccess (idFilter bList mAlliance) (mPos 2 1) (mPos 0 0)))
    (let ((attacker (rangeAccess allianceList enemyPos)))
      (cond ((or (null? enemyPos) (null? attacker)) (nextSt bList))
            ((not (null? (colorFilter attacker mRed))) (makeMove bList (blPos attacker) enemyPos))
            ((and (< 0 (blX attacker)) (= 1 (blY attacker))) (withDraw bList (blPos attacker)))
            ((not (null? attacker)) (makeMove bList (blPos attacker) enemyPos))
            (else (nextSt bList)))))

;왼쪽페이크
(define (leftSideFake bList)
  (define nextSt selectLR)
  (define enemyPos
    (let ((ep (unitAccess (idFilter bList mEnemy) (mPos 0 2) (mPos 3 0))))
      (if (null? ep) null (blPos ep))))
  (define allianceList (unitAccess (idFilter bList mAlliance) (mPos 0 2) (mPos 3 0)))
  (define attacker (rangeAccess allianceList enemyPos))
      (cond ((or (null? enemyPos) (null? attacker)) (nextSt bList))
            ((not (null? (colorFilter attacker mBlue))) (withDraw bList (blPos (colorFilter attacker mBlue))))
            (else (nextSt bList))))
  
;무작위
(define (randomFront bList)
  (define leaderUnit (leftLine (frontLine (colorFilter bList mRed))))
  (fronting bList (blPos leaderUnit)))
  

;우측앞으로
(define (rightsideUp bList)
  (define nextSt randomFront)
  (define leaderUnit (rightLine (frontLine (colorFilter bList mRed))))
  (define frontiers (length (frontLine (idFilter bList mAlliance))))
  (define follower (nearestUnit (colorFilter bList mRed) (blPos leaderUnit)))
  (define nBlue (nearestUnit (colorFilter bList mBlue) (blPos leaderUnit)))
  (cond ((or (null? leaderUnit) (null? follower)) (nextSt bList))
        ((> frontiers 1) (fronting bList (blPos leaderUnit)))
        ((> (distance (blPos leaderUnit) (blPos follower)) 1) (makeMove bList (blPos follower) (blPos leaderUnit))) 
        ((> (distance (blPos leaderUnit) (blPos nBlue)) 1) (makeMove bList (blPos nBlue) (blPos leaderUnit)))
        (else (nextSt bList))))
 
;좌측앞으로
(define (leftsideUp bList)
  (define nextSt randomFront)
  (define leaderUnit (frontLine (leftLine (colorFilter bList mRed))))
  (define frontiers (length (frontLine (idFilter bList mAlliance))))
  (define follower (nearestUnit (colorFilter bList mRed) (blPos leaderUnit)))
  (define nBlue (nearestUnit (colorFilter bList mBlue) (blPos leaderUnit)))
  (cond ((or (null? leaderUnit) (null? follower)) (nextSt bList))
        ((> frontiers 1) (fronting bList (blPos leaderUnit)))
        ((> (distance (blPos leaderUnit) (blPos follower)) 1) (makeMove bList (blPos follower) (blPos leaderUnit))) 
        ((> (distance (blPos leaderUnit) (blPos nBlue)) 1) (makeMove bList (blPos nBlue) (blPos leaderUnit)))
        (else (nextSt bList))))

;우측골로 
(define (rightGoal bList)
  (define nextSt rightsideUp)
  (define leaderUnit (frontLine (rightLine (colorFilter bList mBlue))))
  (define enemyAttack (rangeAccess (idFilter bList mEnemy) (blPos leaderUnit)))
  (define attackReturn (if (null? enemyAttack) null (rangeAccess (idFilter bList mEnemy) (blPos enemyAttack))))
  (define follower (nearestUnit (colorFilter bList mRed) (blPos leaderUnit)))
  (cond ((or (null? leaderUnit) (null? follower) (null? enemyAttack)) (nextSt bList))
        ((null? attackReturn) (makeMove bList (blPos leaderUnit) (blPos enemyAttack)))
        (else (makeSafeMove bList (blPos leaderUnit) (mPos 6 6) nextSt))))
  
;좌측골로 
(define (leftGoal bList)
  (define nextSt leftsideUp)
  (define leaderUnit (frontLine (leftLine (colorFilter bList mBlue))))
  (define enemyAttack (rangeAccess (idFilter bList mEnemy) (blPos leaderUnit)))
  (define attackReturn (if (null? enemyAttack) null (rangeAccess (idFilter bList mEnemy) (blPos enemyAttack))))
  (define follower (nearestUnit (colorFilter bList mRed) (blPos leaderUnit)))
  (cond ((or (null? leaderUnit) (null? follower) (null? enemyAttack)) (nextSt bList))
        ((null? attackReturn) (makeMove bList (blPos leaderUnit) (blPos enemyAttack)))
        (else (makeSafeMove bList (blPos leaderUnit) (mPos 0 6) nextSt))))

;우측 택
(define (selectRightSt bList)
  (if (null? (unitAccess (colorFilter bList mBlue) (mPos 4 4) (mPos 6 6)))
      (rightsideUp bList)
      (rightGoal bList)))

;좌측 택
(define (selectLeftSt bList)
  (if (null? (unitAccess (colorFilter bList mBlue) (mPos 2 4) (mPos 0 6)))
      (leftsideUp bList)
      (leftGoal bList)))

;좌우 택
(define (selectLR bList)
  (if (>= (length (unitAccess (colorFilter bList mRed) (mPos 0 0) (mPos 3 6)))
         (length (unitAccess (colorFilter bList mRed) (mPos 4 0) (mPos 6 6))))
      (selectLeftSt bList)
      (selectRightSt bList)))

;킬링필드 
(define (killingfield bList)
  (define nextSt randomFront)
  (define leaderUnit (leftLine (frontLine (colorFilter bList mRed))))
  (define enemyToKill (rangeAccess bList (blPos leaderUnit)))
  (cond ((null? leaderUnit) (nextSt bList))
        ((null? enemyToKill) (makeMove bList (blPos leaderUnit) (blPos enemyToKill)))
        (else (fronting bList (blPos leaderUnit)))))

;약진앞으로
(define (crosswalk bList)
  (define nextSt killingfield)
  (define walker (leftLine (rearLine (colorFilter bList mRed))))
  (cond ((null? walker) (nextSt bList))
        (else (fronting bList (blPos walker)))))

;오른쪽 사수
(define (rightKeep bList)
  (define nextSt leftKeep)
  (define keeper (oLookup (mPos 6 0) bList))
  (define nearB (nearestUnit (colorFilter bList mBlue) (mPos 6 0)))
  (if (equal? keeper 'bottom) 
      (makeMove bList (blPos nearB) (mPos 6 0))
      (nextSt bList)))
                
;왼쪽사수
 (define (leftKeep bList)
  (define nextSt crosswalk)
  (define keeper (oLookup (mPos 0 0) bList))
  (define nearB (nearestUnit (colorFilter bList mBlue) (mPos 0 0)))
  (if (equal? keeper 'bottom) 
      (makeMove bList (blPos nearB) (mPos 0 0))
      (nextSt bList)))     
  
  
 (define (stSelector bList n)
   (cond ((= n 1) (rightSideDefence bList))
         ((= n 2) (randomFront bList))
         ((= n 3) (rightKeep bList))
         (else (randomFront bList))))
 
(define (mvConv mv)
  (cons (cons (- (caar mv) 3) (- (cdar mv) 3)) (cdr mv)))

(define (move B)
  (define BL (boardToList B))
  (mvConv (stSelector BL 1)))
  

  
;--------------init 함수 도움;;----------

;converseInit : init -> init
;init의 좌표계를 뒤집어줌
(define (converseInit i)
  (cond ((null? i) null)
        (else (cons (cons (converse (caar i)) (cdar i)) 
                    (converseInit (cdr i))))))

(define (transInit i)
  (map (lambda (k) (cons (cons (- (caar k) 3) (- (cdar k) 3)) (cdr k))) i)) 

;--------- init 함수 -------------------

(define init-1
  (list (cons (cons 0 2) mRed)
        (cons (cons 1 2) mRed)
        (cons (cons 4 2) mRed)
        (cons (cons 5 2) mRed)
        (cons (cons 6 2) mRed)
        (cons (cons 0 0) mBlue)
        (cons (cons 6 0) mBlue)
        (cons (cons 1 1) mBlue)
        (cons (cons 5 1) mBlue)
        (cons (cons 6 1) mBlue)))

(define init-2
  (list (cons (cons 0 0) mBlue)
        (cons (cons 1 1) mRed)
        (cons (cons 1 2) mRed)
        (cons (cons 0 1) mBlue)
        (cons (cons 6 0) mBlue)
        (cons (cons 0 2) mRed)
        (cons (cons 6 2) mRed)
        (cons (cons 6 1) mRed)
        (cons (cons 5 1) mBlue)
        (cons (cons 5 0) mBlue)))

(define (init)
  (define ini init-1)
  (if isConverted?
      (transInit (converseInit ini))
      (transInit ini)))
       



;================================================ 보영 ======================================================


;; 인가? 
(define (isEnemy? pos B) 
  (if (equal? (mLookup pos B) 'bottom)
      #f
      (if (equal? (car (mLookup pos B)) mEnemy) #t #f)))

;;아군인가? (아군인지  인지에 따라 A를 B로 바꿔  야 함!!!
(define (isAlliance? pos B) 
  (if (equal? (mLookup pos B) 'bottom)
      #f
      (if (equal? (car (mLookup pos B)) mAlliance) #t #f)))


;; 그 좌표가 비어 있는가? 
(define (isEmpty? pos B)
  (if (equal? (mLookup pos B) 'bottom) #t #f))

;; 닛의 색깔이 빨간색인가;;
;;isRed? Id * color => bool;
(define (isRed? p)
  (if (equal? (cdr p) mRed) #t #f))

;; 닛의 색깔이 파란색인가?
;;isBlue? Id * color  => bool ;;
(define (isBlue? p)
  (if (equal? (cdr p) mBlue) #t #f))

;  이 많은 곳에서 가장 바깥부분부터 우리의  닛의 위치를 찾는다 (빨간색)
;; 형식 => 가까운 화살표의 좌표 부터 하나씩 행을 내 오면서 우리의 빨간색  닛을 찾  
;;      => 그 열에 존재 하지 않으면 다음 열로 넘어가서 같은 방법으로 찾는다.
;; findUnit => 보드 방향 열좌표 행좌표 => 가장 가까운  닛의 위치 

(define (findUnit B n r k)
  (cond ((= n 1)
         (if (> r 3)
         (if (< k 0) (findUnit B 1 (- r 1) 6)
            (if (equal? (mLookup (cons r k) B) 'bottom) (findUnit B 1 r (- k 1))
                     (if (isEnemy? (cons r k) B) (findUnit B 1 r (- k 1))
                         (if (isRed? (mLookup (cons r k) B)) (cons r k) 
                                     (findUnit B 1 r (- k 1))))))
         (findUnit B 2 0 6)))
        
        ((= n 0)
          (if (< k 0) (findUnit B 0 (+ r 1) 6)
            (if (equal? (mLookup (cons r k) B) 'bottom) (findUnit B 0 r (- k 1))
                     (if (isEnemy? (cons r k) B) (findUnit B 0 r (- k 1))
                         (if (isRed? (mLookup (cons r k) B)) (cons r k) 
                                     (findUnit B 0 r (- k 1)))))))
         ((= n 2)
          (if (< r 3)
          (if (< k 0) (findUnit B 2 (+ r 1) 6)
            (if (equal? (mLookup (cons r k) B) 'bottom) (findUnit B 2 r (- k 1))
                     (if (isEnemy? (cons r k) B) (findUnit B 2 r (- k 1))
                         (if (isRed? (mLookup (cons r k) B)) (cons r k) 
                                     (findUnit B 2 r (- k 1))))))
          (findUnit B 1 6 6)))))



;;가장 가까운 파란색  닛의 위치를 찾음

(define (findBlue B n r k)
  (cond ((= n 1)
         (if (< k 0) (findBlue B 1 (- r 1) 6)
            (if (equal? (mLookup (cons r k) B) 'bottom) (findBlue B 1 r (- k 1))
                     (if (isEnemy? (cons r k) B) (findBlue B 1 r (- k 1))
                         (if (isBlue? (mLookup (cons r k) B)) (cons r k) 
                                     (findBlue B 1 r (- k 1)))))))
        ((= n 0)
          (if (< k 0) (findBlue B 0 (+ r 1) 6)
            (if (equal? (mLookup (cons r k) B) 'bottom) (findBlue B 0 r (- k 1))
                     (if (isEnemy? (cons r k) B) (findBlue B 0 r (- k 1))
                         (if (isBlue? (mLookup (cons r k) B)) (cons r k) 
                                     (findBlue B 0 r (- k 1)))))))))


; 파란색  닛을 움직임

(define (moveBlue B pos)
  (cond ((or (= (car pos) 0) (= (car pos) 6))
          (if (isAlliance? (cons (car pos) (+ (cdr pos) 1)) B)
                 (moveUnit B (cons (car pos) (+ (cdr pos) 1)))
                 (cons pos mUp)))
        ((<= (car pos) 3) 
            (if (isAlliance? (cons (- (car pos) 1) (cdr pos)) B) 
                 (moveUnit B (cons (- (car pos) 1) (cdr pos)))
                 (cons pos mLeft)))
        ((> (car pos) 3) 
           (if (isAlliance? (cons (- (car pos) 1) (cdr pos)) B) 
                 (moveUnit B (cons (- (car pos) 1) (cdr pos)))
                 (cons pos mRight)))))

; 파란색  닛을 움직일 위치를 확인 

(define (nearBlue B n)
  (cond ((= n 0) (moveBlue B (findBlue B 1 6 6)))
        ((= n 1) (moveBlue B (findBlue B 0 0 6)))))
                 
;  닛을 움직임 
(define (moveUnit-1 B pos)
  (cond ((equal? (isAlliance? (cons (- (car pos) 1) (cdr pos)) B) #f) (cons pos mLeft))
        ((equal? (isAlliance? (cons (car pos) (- (cdr pos) 1)) B) #f) (cons pos mDown))
        (else (moveUnit B (cons (- (car pos) 1) (cdr pos)) ))))

(define (moveUnit-2 B pos)
   (cond ((equal? (isAlliance? (cons (+ (car pos) 1) (cdr pos)) B) #f) (cons pos mRight))
         ((equal? (isAlliance? (cons (car pos) (- (cdr pos) 1)) B) #f) (cons pos mDown))
         (else (moveUnit B (cons (+ (car pos) 1) (cdr pos))))))

(define (moveUnit-3 B pos)
  (cond ((equal? (isAlliance? (cons (car pos) (+ (cdr pos) 1)) B) #f) (cons pos mUp))
        ((equal? (isAlliance? (cons (+ (car pos) 1) (cdr pos)) B) #f) (cons pos mRight))
        ((equal? (isAlliance? (cons (- (car pos) 1) (cdr pos)) B) #f) (cons pos mLeft))
        ((equal? (isAlliance? (cons (car pos) (- (cdr pos) 1)) B) #f) (cons pos mDown))))

(define (moveUnit B pos)
  (if (= (cdr pos) 5)
      (cond ((= (car pos) 0) 
             (if (isAlliance? (cons (+ (car pos) 1) (cdr pos)) B)
                              (moveUnit-3 B (cons (+ (car pos) 1) (cdr pos))) 
                              (cons pos mRight)))
            ((= (car pos) 6) 
             (if (isAlliance? (cons (- (car pos) 1) (cdr pos)) B)
                              (moveUnit-3 B (cons (- (car pos) 1) (cdr pos)))
                              (cons pos mLeft)))
            (else     
                 (cond ((> (car pos) 3) 
                        (if (isAlliance? (cons (- (car pos) 1) (cdr pos)) B)
                            (moveUnit-3 B (cons (- (car pos) 1) (cdr pos))) 
                        (nearBlue B 0)))
                        ((<= (car pos) 3) 
                         (if (isAlliance? (cons (+ (car pos) 1) (cdr pos)) B)
                             (moveUnit-3 B (cons (+ (car pos) 1) (cdr pos)))
                             (nearBlue B 1))))))
      
      (cond ((= (car pos) 0) 
             (if (isAlliance? (cons (car pos) (+ (cdr pos) 1)) B)
                  (moveUnit-1 B (cons (car pos) (+ (cdr pos) 1)))
                  (cons pos mUp)))
            ((= (car pos) 6) 
            (if (isAlliance? (cons (car pos) (+ (cdr pos) 1)) B)
                 (moveUnit-2 B (cons (car pos) (+ (cdr pos) 1)))
                     (cons pos mUp)))
            ((and (= (car pos) 5) (= (cdr pos) 6)) (nearBlue B 0))
            ((and (= (car pos) 1) (= (cdr pos) 6)) (nearBlue B 1))
            ((<= (car pos) 3) 
             (if (isAlliance? (cons (- (car pos) 1) (cdr pos)) B) 
                 (moveUnit-3 B (cons (- (car pos) 1) (cdr pos)))
                 (cons pos mLeft)))
            ((> (car pos) 3)   
             (if (isAlliance? (cons (+ (car pos) 1) (cdr pos)) B) 
                 (moveUnit-3 B (cons (+ (car pos) 1) (cdr pos)))
                 (cons pos mRight))))))

; list 안에 그 위치가 있는지 확인 
(define (checklist blist pos)
  (if (null? blist) #f
      (if (equal? (car (car blist)) pos) #t (checklist (cdr blist) pos))))



(define (attack-1 blist B)
  (cond ((null? blist) (moveUnit B (findUnit B 2 0 6)))
        ((checklist blist (cons 1 1)) (cons (cons 1 1) mLeft))
        ((checklist blist (cons 0 2)) (cons (cons 0 2) mDown))
        ((checklist blist (cons 0 0)) (cons (cons 0 0) mUp))
        (else (moveUnit B (findUnit B 2 0 6)))))


(define (attack-2 blist B)
  (cond ((null? blist) (moveUnit B (findUnit B 2 0 6)))
        ((checklist blist (cons 1 2)) (cons (cons 1 2) mLeft))
        ((checklist blist (cons 0 1)) (cons (cons 0 1) mUp))
        (else (moveUnit B (findUnit B 2 0 6)))))

(define (attack-3 blist B)
  (cond ((null? blist) (moveUnit B (findUnit B 2 0 6)))
        ((checklist blist (cons 1 0)) (cons (cons 1 0) mUp))
        ((checklist blist (cons 0 1)) (cons (cons 0 1) mRight))
        (else (moveUnit B (findUnit B 2 0 6)))))

(define (attack-4 blist B)
  (cond ((null? blist) (moveUnit B (findUnit B 2 0 6)))
        ((checklist blist (cons 2 0)) (cons (cons 2 0) mLeft))
        ((checklist blist (cons 1 1)) (cons (cons 1 1) mDown))
        ((checklist blist (cons 0 0)) (cons (cons 0 0) mRight))
        (else (moveUnit B (findUnit B 2 0 6)))))
                                            
(define (attack-5 blist B)
  (cond ((null? blist) (moveUnit B (findUnit B 2 0 6)))
        ((checklist blist (cons 5 1)) (cons (cons 5 1) mRight))
        ((checklist blist (cons 6 0)) (cons (cons 6 0) mUp))
        (else (moveUnit B (findUnit B 2 0 6)))))

(define (attack-6 blist B)
  (cond ((null? blist) (moveUnit B (findUnit B 2 0 6)))
        ((checklist blist (cons 4 0)) (cons (cons 4 0) mRight))
        ((checklist blist (cons 5 1)) (cons (cons 5 1) mDown))
        ((checklist blist (cons 6 0)) (cons (cons 6 0) mLeft))
        (else (moveUnit B (findUnit B 2 0 6)))))
      
     
(define (checkPoint B)
  (cond ((isEnemy? (cons 0 1) B) (attack-1 (rangeAccess (idFilter (boardToList B) mAlliance) (cons 0 1)) B))
        ((isEnemy? (cons 1 0) B) (attack-4 (rangeAccess (idFilter (boardToList B) mAlliance) (cons 1 0)) B))
        ((isEnemy? (cons 6 1) B) (attack-5 (rangeAccess (idFilter (boardToList B) mAlliance) (cons 6 1)) B))
        ((isEnemy? (cons 5 0) B) (attack-6 (rangeAccess (idFilter (boardToList B) mAlliance) (cons 5 0)) B))
        ((isEnemy? (cons 0 2) B) (attack-2 (rangeAccess (idFilter (boardToList B) mAlliance) (cons 0 2)) B))
        ((isEnemy? (cons 1 1) B) (attack-3 (rangeAccess (idFilter (boardToList B) mAlliance) (cons 1 1)) B))
        (else (moveUnit B (findUnit B 2 0 6))))) 

(define (move-1 B)
  (checkPoint B))

;============================================================================================================

    

 